//+------------------------------------------------------------------+
//|                                           Rectangle Extender.mq4 |
//|                                      Copyright @ 2022, samsha786 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright @ 2022, samsha786"
#property link      ""
#property version   "2.00"
#property strict
#property indicator_chart_window
#property indicator_plots 0

enum ENUM_PLOT_TYPE
  {
   Rect=0,       // Plot Rectangle
   Rect_Line=1,   // Plot Rectangle + Mid Line
  };
  
input ENUM_PLOT_TYPE  Plot_What = Rect;
input bool  Rectangle_Fill = true;
input color Rectangle_Color = clrDarkSlateGray;
input color Line_Color = White;


datetime bars = -1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
   //--- indicator buffers mapping
   EventSetMillisecondTimer(100);
   ChartSetInteger(0,CHART_EVENT_OBJECT_CREATE,true);
   
   //---
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   
   //--- return value of prev_calculated for next call
   return(rates_total);
}
//+------------------------------------------------------------------+
void OnTimer()
 {
      for (int r = 0; r < ObjectsTotal(0); r++)
      {
         string name = ObjectName(0,r,0);
         if (ObjectGetInteger(0,name,OBJPROP_TYPE) == OBJ_RECTANGLE)
          {
         double p1 = ObjectGetDouble(0,name, OBJPROP_PRICE);
         double p2 = ObjectGetDouble(0,name, OBJPROP_PRICE,1);
         ObjectSetInteger(0,name, OBJPROP_FILL, Rectangle_Fill);
         ObjectSetInteger(0,name, OBJPROP_COLOR, Rectangle_Color);
         ObjectSetInteger(0,name, OBJPROP_TIME,1,iTime(_Symbol,_Period,0));
         ObjectSetString(0,name,OBJPROP_TEXT,DoubleToString(MathAbs(p1-p2)/_Point,0));
          } 
         if(Plot_What==Rect_Line&&ObjectFind(0,name)==0)
          {
         long t1 = ObjectGetInteger(0,name, OBJPROP_TIME);
         long t2 = ObjectGetInteger(0,name, OBJPROP_TIME,1);
         double p1 = ObjectGetDouble(0,name, OBJPROP_PRICE);
         double p2 = ObjectGetDouble(0,name, OBJPROP_PRICE,1);
         double line = (p1 + p2) / 2.0; 
         ObjectSetInteger(0,name+"Line", OBJPROP_TIME, t1);
         ObjectSetInteger(0,name+"Line", OBJPROP_TIME,1, t2);
         ObjectSetDouble(0,name+"Line", OBJPROP_PRICE, line);
         ObjectSetDouble(0,name+"Line", OBJPROP_PRICE,1, line);
         ObjectSetInteger(0,name+"Line", OBJPROP_STYLE, STYLE_SOLID);
         ObjectSetInteger(0,name+"Line", OBJPROP_COLOR, Line_Color);
         ObjectSetInteger(0,name+"Line", OBJPROP_BACK, false);
         ObjectSetInteger(0,name+"Line", OBJPROP_TIME,1,iTime(_Symbol,_Period,0));
          }   
      }
 }
//+------------------------------------------------------------------+
//| Custom indicator on chart event function                         |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{ 
   //--- Check the event belongs to the user events
  if (id == CHARTEVENT_OBJECT_CREATE)
   {
      if(ObjectGetInteger(0,sparam,OBJPROP_TYPE)==OBJ_RECTANGLE)
       {
         if(Plot_What==Rect_Line)
          {
         long t1 = ObjectGetInteger(0,sparam, OBJPROP_TIME);
         long t2 = ObjectGetInteger(0,sparam, OBJPROP_TIME,1);
         double p1 = ObjectGetDouble(0,sparam, OBJPROP_PRICE);
         double p2 = ObjectGetDouble(0,sparam, OBJPROP_PRICE,1);
         double line = (p1 + p2) / 2.0; 
          if(ObjectFind(0,sparam+"Line")<0)
           {
         ObjectCreate(0,sparam+"Line", OBJ_TREND, 0, 0, 0);
           }
         ObjectSetInteger(0,sparam+"Line", OBJPROP_TIME, t1);
         ObjectSetInteger(0,sparam+"Line", OBJPROP_TIME,1, t2);
         ObjectSetDouble(0,sparam+"Line", OBJPROP_PRICE, line);
         ObjectSetDouble(0,sparam+"Line", OBJPROP_PRICE,1, line);
         ObjectSetInteger(0,sparam+"Line", OBJPROP_STYLE, STYLE_SOLID);
         ObjectSetInteger(0,sparam+"Line", OBJPROP_COLOR, Line_Color);
         ObjectSetInteger(0,sparam+"Line", OBJPROP_BACK, false);
         ObjectSetInteger(0,sparam+"Line", OBJPROP_TIME,1,iTime(_Symbol,_Period,0));
          }
       }
     }
      else 
  if (id == CHARTEVENT_OBJECT_CLICK)
   {
      if (StringSubstr(ObjectGetString(0,sparam,OBJPROP_NAME),StringLen(sparam)-4)=="Line")
       {
         ObjectDelete(0,sparam);
         string name_line = StringSubstr(sparam,0,StringLen(sparam)-4);
         ObjectDelete(0,name_line);
       }
   }
}
//+------------------------------------------------------------------+
